﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HLWebOKBAdminPlugin.OKBAdministrationService;
using HLWebOKBAdminPlugin.Helpers;

namespace HLWebOKBAdminPlugin.Models
{
    public class ProblemModel
    {
        /// <summary>
        /// Get all Problems.
        /// </summary>
        public List<Problem> Problems
        {
            get
            {
                AdministrationServiceClient adminClient = Admin.GetClientFactory("okbtester", "okbtester");
                IList<Problem> problemList = new List<Problem>();
                Problem[] problems = adminClient.GetProblems();
                return problems.ToList<Problem>();
            }
        }

        public List<ProblemClass> ProblemClasses {
            get {
                AdministrationServiceClient adminClient = Admin.GetClientFactory("okbtester", "okbtester");
                IList<ProblemClass> problemClassList = new List<ProblemClass>();
                ProblemClass[] problemClass = adminClient.GetProblemClasses();
                return problemClass.ToList<ProblemClass>();
            }
        }

        public List<Platform> Plattforms {
            get {
                AdministrationServiceClient adminClient = Admin.GetClientFactory("okbtester", "okbtester");
                IList<Platform> plattformList = new List<Platform>();
                Platform[] plattforms = adminClient.GetPlatforms();
                return plattforms.ToList<Platform>();
            }
        }

        /// <summary>
        /// Curretn Problem (for Detail)
        /// </summary>
        public Problem Problem { get; set; }

        public void SaveProblem(Problem problem) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory("okbtester", "okbtester");
            adminClient.UpdateProblem(problem);
        }

        public void CreateProblem(Problem problem) {
            AdministrationServiceClient adminClient = Admin.GetClientFactory("okbtester", "okbtester");
            adminClient.AddProblem(problem);
        }

    }
}